package org.bitbucket.bradleysmithllc.etlunit.feature.oracle_database;

import com.google.inject.Injector;
import org.bitbucket.bradleysmithllc.etlunit.feature.FeatureModule;
import org.bitbucket.bradleysmithllc.etlunit.feature.AbstractFeature;
import org.bitbucket.bradleysmithllc.etlunit.feature.database.DatabaseFeatureModule;

import javax.inject.Inject;
import java.util.Arrays;
import java.util.List;

@FeatureModule
public class OracleDatabaseFeatureModule extends AbstractFeature {
	private DatabaseFeatureModule databaseFeatureModule;
	private OracleDatabaseImplementation oracleSQLDatabaseImplementation;

	private static final List<String> prerequisites = Arrays.asList("database");

	@Inject
	public void setDatabaseFeatureModule(DatabaseFeatureModule module)
	{
		databaseFeatureModule = module;
	}

	@Override
	public void dispose()
	{
		oracleSQLDatabaseImplementation.dispose();
	}

	@Override
	public List<String> getPrerequisites() {
		return prerequisites;
	}

	public String getFeatureName() {
		return "oracle-database";
	}

	@Override
	public void initialize(Injector inj)
	{
		oracleSQLDatabaseImplementation = postCreate(new OracleDatabaseImplementation());
		databaseFeatureModule.addDatabaseImplementation(oracleSQLDatabaseImplementation);
	}
}